<?php

namespace Treewec\FileSystem;

/**
 * Test class for Path.
 * Generated by PHPUnit on 2012-03-25 at 16:41:51.
 * @group filesystem
 */
class PathTest extends \PHPUnit_Framework_TestCase {

    private $invalidCharacters;

    protected function setUp() {
        $this->invalidCharacters = array(
            '?', '"', '<', '>', ':', '*', '|',
            '^', ';', ' ', '\\', '../', '..'
        );
    }

    public function testIsValid() {        
        parent::assertTrue(Path::isValid("hello/world"));

        parent::assertFalse(Path::isValid(null));
        foreach ($this->invalidCharacters as $invalidChar) {
            parent::assertFalse(Path::isValid("hello/world" . $invalidChar));
        }
    }

    public function testIsHidden() {        
        parent::assertTrue(Path::isHidden('.htaccess'));
        parent::assertTrue(Path::isHidden(TREEWEC_PREFIX_OF_HIDDEN_FILES . 'name'));
        parent::assertTrue(Path::isHidden('folder/hierarchy/' . TREEWEC_PREFIX_OF_HIDDEN_FILES . 'name'));
        parent::assertTrue(Path::isHidden(TREEWEC_PREFIX_OF_HIDDEN_FILES . 'folder/hierarchy/name'));
        parent::assertFalse(Path::isHidden('folder/pre' . TREEWEC_PREFIX_OF_HIDDEN_FILES . 'name'));
        parent::assertFalse(Path::isHidden(null));
        // + tests for default and user hidden filenames (in FilenameTest and HiddenFilenamesTest)
    }

    public static function testGetFullFilename() {
        parent::assertEquals('directory', Path::getFullFilename('directory/'));
        parent::assertEquals('file' . TREEWEC_DEFAULT_FILE_EXTENSION, Path::getFullFilename('directory/file'));
        parent::assertEquals('file.php' . TREEWEC_DEFAULT_FILE_EXTENSION, Path::getFullFilename('directory/file.php'));
    }

    public static function testGetFilenameFromPath() {
        parent::assertEquals('', Path::getFilenameFromPath(new \Exception()));
        parent::assertEquals('', Path::getFilenameFromPath(''));
        parent::assertEquals('directory', Path::getFilenameFromPath('directory/'));
        parent::assertEquals('file', Path::getFilenameFromPath('directory/file'));
        parent::assertEquals('file.php', Path::getFilenameFromPath('directory/file.php'));
    }

    public static function testGetFilenameExtension() {
        parent::assertEquals('', Path::getFilenameExtension(new \Exception()));
        parent::assertEquals('', Path::getFilenameExtension(''));
        parent::assertEquals('', Path::getFilenameExtension('directory/'));
        parent::assertEquals(TREEWEC_DEFAULT_FILE_EXTENSION, Path::getFilenameExtension('directory/file'));
    }

    public function testToScreen() {
        $path = "hello/world";
        parent::assertEquals(Path::toScreen($path), $path);
        parent::assertEquals(Path::toScreen(array()), '');
    }

    public function testToFileSystem() {
        $path = "hello/world";
        parent::assertEquals(Path::toFileSystem($path), $path);
        parent::assertEquals(Path::toFileSystem(array()), '');
    }

}

?>